<?php
require_once('vb_api_client.php');
class PageNav {
    // Takes pagenav object from json response from VBApiClient call return
    public function __construct($json = '') {
		$this->data = $json;
    }
    
    protected $data;

    public function getHtml() {
        if(empty($this->data)) {
            return self::defaultHtml();
        }
        $html = '';       
        $html = $html . '<div class="pagecontainer">';
        $foundlast = false;
        $first = true;
        if($this->data['pagenumber'] !== 1) {
            $html = $html . '<div class="prev"><a href="'.self::getLink($this->data['pagenumber'] - 1).'"><img src="_css/page_prev.png" /></a></div>';
        }
        $lastnumber = 1;
        foreach($this->data['pagenav'] as $key => $value) {
            
            $altdata = 'pagenumbers';
            $selected = '';
            if($first && 1 !== $value['curpage']) {              
                $html = $html . '<div class="pagelink"><a href="'.self::getLink(1).'">1</a></div>';
            }
            if($value['curpage'] !== 1 && $value['curpage'] != ($lastnumber + 1)) {
                // Elide for now, gets too large for big page navs
                //$html = $html . '<div class="elipsis">...</div>';
            }
            $first = false;
            if($this->data['pagenumber'] === $value['curpage']) {
                $altdata =  'numbers';
                $selected = ' selected';
            }
            if($value['curpage'] === $this->data['totalpages']) {
                $foundlast = true;
            }
            $html = $html . '<div class="pagelink'.$selected.'"><a href="'.self::getLink($value['curpage']).'">'.$value['curpage'].'</a></div>';
            $lastnumber = $value['curpage'];
        }
        
        if(!$foundlast) {
            $html = $html . '<div class="pagelink"><a href="'.self::getLink($this->data['totalpages']).'">'.$this->data['totalpages'].'</a></div>';
        }
        
        if($this->data['pagenumber'] !== $this->data['totalpages']) {
            $html = $html . '<div class="next"><a href="'.self::getLink($this->data['pagenumber'] + 1).'"><img src="_css/page_next.png" /></a></div>';
        }
        
        return $html . '</div>';
    }
    private static $blacklist = array(
        "all" => array(
            "do"
        ),
        "category_item.php" => array(
            "goto"
        )
    );
    public static function getLink($pagenumber) {
        $script_name = basename($_SERVER['SCRIPT_NAME']);
        
        $query_array = array();
        parse_str($_SERVER['QUERY_STRING'], $query_array);
        
        foreach(self::$blacklist['all'] as $remove) {
            unset($query_array[$remove]);
        }
        
		$script_bl = @self::$blacklist[$script_name];
		if(isset($script_bl)) {		
			foreach($script_bl as $remove) {
				unset($query_array[$remove]);
			}
		}
        
        $query_array['page'] = $pagenumber;
        
        return $script_name . '?' . http_build_query($query_array);
    }
    
    public static function defaultHtml() {
        return '<div class="pagecontainer"><div class="pagelink selected"><a href="'.self::getLink(1).'">1</a></div></div>';
    }
    
    // Searches a VBApiClient response for a pagenav object, and if found returns a PageNav class object.
    // Otherwise, return null.
    public final static function get($full_response, $depth = 2) {        
        $page_nav_array = VBApiClient::getKeysFromResponse($full_response, array('pagenav'), array(), $depth);
        
        if(isset($page_nav_array['pagenav'])) {
            return new PageNav($page_nav_array['pagenav']);
        }
        return null;
    }
}
?>